/*
 * File......: XCONNWS.PRG
 * Author....: Steve Larsen
 * CIS ID....: 76370,1532
 * Date......: $Date$
 * Revision..: $Revision$
 * Log file..: $Logfile$
 *
 * This is an original work by Steve Larsen and is placed in the
 * public domain.
 *
 * Modification history:
 * ---------------------
 *
 * $Log$
 *
 */


/*  $DOC$
 *  $FUNCNAME$
 *      Overview
 *  $CATEGORY$
 *      Connection/Workstation
 *  $ONELINER$
 *      Connection and Workstation Services
 *  $DESCRIPTION$
 *      
 *      The Connection and Workstation Services provide functions for 
 *      communicating with the workstation shell and the file servers. With
 *      these functions one may log into or out of different file servers
 *      on the network, determine the workstation's network environment,
 *      and learn useful information about objects logged into the various
 *      file servers on the network.
 *      
 *      These functions provide low-level access to NetWare and the Shell,
 *      so you must take care to insure yourself of your environment.  Some
 *      simple rules should be considered:
 *
 *      - Make sure you are in fact running under the NetWare shell.  You 
 *        should generally test for the Shell's presence before performing
 *        any C/W operation, failing to do so might not trigger an error 
 *        until your program attempts to do something critical.
 *      
 *      - Also maintain at least one attached server.  Since all network
 *        requests are routed through the "default server", detaching from
 *        your last server will effective sever your ties to the net.
 *      
 *      - Always be aware of your "preferred" or default server.  Simply
 *        attaching to a server does not necessarily guarantee that
 *        subsequent requests, such as logging in, will go to the desired
 *        server.
 *      
 *      Enjoy!
 *      
 *  $END$
 */

static function xconnws()
   return nil
