#pragma W_MAC_REDEF-
#pragma W_FUNC_PROC-
#pragma W_INDIRECT-

#include MKSTRING.HDR
#include MKSCREEN.HDR
#include SYSTEM.HDR
#include SCREEN.HDR
#include STRING.HDR
#include DATE.HDR

#define CRON_HEAD "                              MK CRON Version 1.0                               "
#define CRON_FOOT "                     Unternehmensberatung Kalkhoff (C) 1992                     "
#define NOTHING   "unbenutzt"
#define NODEF     "nicht def."

VARDEF EXTERN
   LOGICAL     use_scrn_save
   LOGICAL     use_log_file
   CHAR( 12 )  crn_file
   CHAR( 08 )  end_time
   CHAR( 128 ) log_file
   BYTE        palette[5]
ENDDEF

 ******************************************************************************
 *									      *
 *  Programm        : MKCRON V1.0 			  (C) 1992 Kalkhoff   *
 *  Modul           : CRONSCRN						      *
 *  Autor           : M.T. Kalkhoff					      *
 *  letzte nderung : 07.09.1992					      *
 *									      *
 *  Aufgabe         : Die Routine CRONSCRN baut den Standardbildschirm des    *
 *		      Programms auf.					      *
 *									      *
 ******************************************************************************	
PROCEDURE CronScrn

   Fill( 01, 00, 23, 79, "" , "", palette[0], palette[0], 0 )
   Fill( 03, 02, 21, 45, &DOUBLE_BOX, " ", palette[0], palette[0], 6 )
   Fill( 03, 48, 14, 77, &DOUBLE_BOX, " ", palette[0], palette[0], 6 )
   Fill( 16, 48, 21, 77, &DOUBLE_BOX, " ", palette[0], palette[0], 6 )
   HBorderLine( 18, 02, 44, "ĺ", palette[0] )
   FastWrite( 00, 00, &CRON_HEAD, palette[1] )
   FastWrite( 24, 00, &CRON_FOOT, palette[1] )
   SayAt( 03, 17, "[ Task Liste ]", palette[0] )
   SayAt( 03, 58, "[ Info ]", palette[0] )
   SayAt( 05, 51, "Aktuelle Zeit:", palette[2] )
   SayAt( 06, 51, "Programmende :", palette[2] )
   SayAt( 07, 51, "akt. Datum   :", palette[2] )
   SayAt( 09, 51, "Steuerdatei  :", palette[2] )
   SayAt( 10, 51, "Logbuch ist  :", palette[2] )
   SayAt( 11, 51, "Screensave in:", palette[2] )
   SayAt( 11, 72, "sec", palette[2] )
   SayAt( 18, 19, "[ Status ]", palette[0] )
   SayAt( 17, 54, "Entwicklungssystem", palette[2] )
   SayAt( 19, 52, "FCO 2.4 / MK Adv. 2.4", palette[0] )

ENDPRO

 ******************************************************************************
 *									      *
 *  Programm	    : MKCRON V1.0   			  (C) 1992 Kalkhoff   *
 *  Modul	    : CRONUSERSCRN					      *
 *  Autor           : M.T. Kalkhoff					      *
 *  letzte nderung : 07.09.1992					      *
 *									      *
 *  Aufgabe         : Im Gegensatz zur Prozedur CRONSCRN erfolgt in der nun   *
 *		      folgenden Routine die Darstellung aller Texte, welche   *
 *		      in irgendeiner Art variabel sind und somit auch durch   *
 *		      Schalter in der Kommandozeile abhngig sind.            *
 *								              *
 ******************************************************************************
PROCEDURE CronUserScrn

   IF XEmpty( &TYPE_CHAR, end_time )
      SayAt( 06, 66, &NODEF, palette[0] )
   ELSE
      SayAt( 06, 66, end_time, palette[0] )
   ENDIF

   SayAt( 07, 66, Dtoc( Today() ), palette[0] )
   SayAt( 09, 66, BeforeAtNum( ".", crn_file, 1, 0 ), palette[0] )

   IF use_log_file
      IF At( "\", log_file ) > 0
         SayAt( 10, 66, SubStr( log_file, Rat( "\", log_file ) + 1, 12 ), palette[0] )
      ELSE
         SayAt( 10, 66, SubStr( log_file, At( ":", log_file ) + 1, 12 ), palette[0] )
      ENDIF
   ELSE
      SayAt( 10, 66, &NOTHING, palette[0] )
   ENDIF

   IF use_scrn_save
      SayAt( 11, 72, "sec", palette[2] )
   ELSE
      SayAt( 11, 66, &NOTHING, palette[0] )
   ENDIF

   SetRC( 0, 0 )

ENDPRO