/*
 * File......: CHKCON.PRG
 * Author....: Glenn Scott
 * CIS ID....: 71620,1521
 * Date......: $Date$
 * Revision..: $Revision$
 * Log file..: $Logfile$
 * 
 * This is an original work by Glenn Scott and is placed in the
 * public domain.
 *
 * Modification history:
 * ---------------------
 *
 * $Log$
 *
 */


/*  $DOC$
 *  $FUNCNAME$
 *     FN_CHKCONP()
 *  $CATEGORY$
 *     File Server
 *  $ONELINER$
 *     Check console privleges
 *  $SYNTAX$
 *
 *     fn_chkConP() -> lIsOperator
 *
 *  $ARGUMENTS$
 *
 *     None
 *
 *  $RETURNS$
 *
 *     <lIsOperator>, logical TRUE (.t.) if the current user is a 
 *     console operator, FALSE (.f.) if the user is not.
 *
 *  $DESCRIPTION$
 *
 *     This call provides a method for determining whether or not 
 *     a user is a "console operator."  Console operators can 
 *     clear connections and down the file server.
 *
 *     THIS CALL ONLY WORKS ON NETWARE 286.     
 *
 *  $EXAMPLES$
 *
 *  $SEEALSO$
 *
 *  $INCLUDE$
 *
 *  $END$
 */

#include "netto.ch"

function fn_chkConP()
  return _fnReq( 227, I2BYTE( 200 ), W2HILO( 0 ) ) == 0

