/* MYCLASSY.CH for OBJECTS.LIB VER 1.2
*  for syntax compabitlity with CLASSY
*
*  This headerfile was written by Dieter Stelzner, DS-Datasoft
*                                 Compuserv adress: 100031, 1315
*
* Not supported:
* - Hidden instances and methods
* - Class messages, methods, instances
*
* additional:
* Whith multiinheritance is a super/parent call also possible.
* A message to the first parent can be sended normally ::parent:method()
* A message to the any other parent can be sended via the parent classname
* ::parent:method() IN <parentname>
*
* Attention!!!:
* The max. number of parameters which can be passed to a method is set
* with constant UPARAMS to 10. If necessary you can increase the parameters
* just with adding , x11, x12...
****************/

#define OBJ_EXPORTED            0
#define OBJ_PROTECTED           1
#define OBJ_HIDDEN              1
#define UPARAMS                 x1,x2,x3,x4,x5,x6,x7,x8,x9,x10

#command EXPORTED:       =>      nScope := OBJ_EXPORTED
#command VISIBLE:        =>      nScope := OBJ_EXPORTED
#command HIDDEN:         =>      nScope := OBJ_HIDDEN
#command PROTECTED:      =>      nScope := OBJ_PROTECTED

#xtranslate READONLY => PROTECTED
#xtranslate :: => Self:
#xtranslate FUNC   => FUNCTION
#xtranslate PROC   => PROCEDURE
#xtranslate SUPER  => PARENT
#xtranslate DEFERRED  => NULL
#xtranslate CONSTRUCTOR =>
#xtranslate CTOR        =>


/************
* Open Class definition
*************/
#xcommand CREATE CLASS <ClassName> [ FROM <Parent1>] [ ,<ParentN> ] => ;
          function <ClassName>() ;;
             static nClassHandle, abParents ;;
             local nscope:=0 ;;
                if nClassHandle == nil ;;
                   ClsNew( <"ClassName"> ,;
                   abParents := { [ {|| <Parent1>()} ] ;
                                  [,{|| <ParentN>()} ] } ) ;;
                   [#define PARENT <"Parent1">]


/************
* Define Class instances
*************/
#xcommand VAR <cVar1> [,<cVarN>] => ;
            ClsAddData( <"cVar1">, nScope ) ;
         [; ClsAddData( <"cVarN">, nScope ) ]

#xcommand VAR <cVar1> [,<cVarN>] PROTECTED => ;
            ClsAddData( <"cVar1">, 1 ) ;
         [; ClsAddData( <"cVarN">, 1 ) ]


/************
* Define Class methods/messages
*************/
#xcommand METHOD <MethodName> [,<MethodN>] => ;
            ClsAddMethod( upper(<"MethodName">), ;
                         {|self, UPARAMS| <MethodName>(Self, UPARAMS)} );
           [;ClsAddMethod( upper(<"MethodN">), ;
                         {|self, UPARAMS| <MethodN>(Self, UPARAMS)} )]

//--- Message <CallName> Method <MethFuncName>
//--- this method can only invoked with the messagename
//------------------------------------------------------
#xcommand MESSAGE <Message> METHOD <MethodName> => ;
            ClsAddMethod( upper(<"Message">), ;
                         {|self, UPARAMS| <MethodName>(Self, UPARAMS)} )

//--- NULL/Deferred method
//------------------------
#xcommand METHOD <MethodName> NULL => ;
            ClsAddMethod( Upper( <"MethodName"> ), { || nil } )

/**************
* End of Classdefinition
***************/
#xcommand ENDCLASS => ;
                nClassHandle = nClsMake() ;;
             end ;;
          return(__ClassIns(nClassHandle))



/**************
* Method functions
* METHOD FUNC <name>(para,...)
* METHOD PROC <name>(para,...)
* METHOD <name>(para,...)     ==> static function
***************/
#xcommand METHOD FUNCTION <MethodName>([<para,...>])   => ;
            static function <MethodName>(self [, <para>])

#xcommand METHOD PROCEDURE <MethodName>([<para,...>])   => ;
            static procedure <MethodName>(self [, <para>])

#xcommand METHOD <MethodName>([<para,...>])   => ;
            static function <MethodName>(self [, <para>])


/************
* firts parent class init, only the first parent init() can be invoked
* this init is also possible (not in Classy) when there is a
* multi inheritance
*
* method func init(a, b, c, d), new(c, d)  super init method: new()
* method func init(a, b, c, d), (c, d)     standard parent init method: Init()
*************/
#xcommand METHOD FUNCTION <MethodName>([<para,...>]) ;
                          [, <cIniMeth>([<inipara,...>])] ;
          => static function <MethodName>(self [, <para>]);
            [;::parent:<cIniMeth>(<inipara>)]


#xcommand METHOD FUNCTION <MethodName>([<para,...>]) ;
                          [, ([<inipara,...>])] ;
          => static function <MethodName>(self [, <para>]);
            [;::parent:INIT(<inipara>)]



/**************
* Calls to Superclass for any parent class
* ::parent:method()    only first parent
*
* call to any other parent. this is incombatiple to classy
* ::parent:method IN <parentname> any parent
***************/

#xtranslate ::Parent:<Method>([<uPara,...>])  => ;
            eval( bClsMethod(upper(PARENT), upper(<"Method">)), ;
                  self [,<uPara>] )

#xtranslate ::Parent:<Method>([<uPara,...>]) IN <cparent> => ;
            eval( bClsMethod(upper(<"cparent">), upper(<"Method">)), ;
                  self [,<uPara>] )


