#ifdef CLASSY
   #include "classy2.ch"
#else
   #include "myclassy.ch"
#endif

/*************************************************************************
* Sample programm for public domain class library OBJECTS.LIB with a
* rewritten headerfile MYCLASS.CH for compatibilty with CLASSY.LIB
**************************************************************************/
PROC Main
LOCAL o1, o2
o1 := Sample():New("Huber", "America", 0, 0, 24, 79)
o2 := Sample():New("Duck", "America")

o1:Person("Meyer", "Man")
o1:cName := "Gustav"
o1:Land("Germany")
o1:Ort("Berlin")

o2:Person("Daisy", "fem")
o1:Ort("New York")

o1:SayData()
o2:SayData()

RETURN


/*************************************************************************
* sample Class with multi inheritance
* ( the get-system can be inherited with the class TGet)
**************************************************************************/
CREATE CLASS Sample FROM Country, Living, Tbrowse
  VAR read1, read2

EXPORT:
  VAR read3 ReadOnly
  VAR cName, cMale

  MESSAGE New METHOD Init
  METHOD Person
  METHOD SayData
ENDCLASS

/**************************************************************************
* init func, with CLASSY in this way only possible when no multiinheritance
* also not possible with direct call in this way  ::super:init(cLand)
* With OBJECT.LIB and MYCLASSY.CH you can init the first parent in the
* declaration line or with the call ::super:init(cLand)
* All other parents you can init with the following call
* ::super:new() IN living
* ::<super/parent>:<initmessage> IN <parentname>
*
* f.e. Tbrowse init:
METHOD FUNCTION Init( nRow, nLeft, nBottom, nRight ), New( nRow, nLeft, nBottom, nRight )

***************************************************************************/
METHOD FUNCTION Init( cName, cLand, nRow, nLeft, ;
                      nBottom, nRight ) , Init(cLand)
  ::cName := cName
  ::cMale := "M"
  ::parent:new(nRow, nLeft, nBottom, nRight) IN TBrowse
  ::autolite := .T.
  ::nTop:=2
  ::nLeft:=2
  ::nRight:=50
  ::nBottom:=20
  ::parent:new() IN living      // any parent invoke with the parent's name

RETURN Self

/**********************/
METHOD FUNCTION Person(cName, cMale)
  ::cName := cName
  ::cMale := cMale
  ::SayData()
RETURN Self

/**********************/
METHOD FUNCTION SayData()
  QOUT(::cName, ::cMale, ::cLand, ::cOrt)
RETURN Self